/**
 * A non-empty list of strings.
 * 
 * @author Stephen Bloch
 * @version 1, 2 March 2009
 */
public class NESL extends StringList
{
    // instance variables - replace the example below with your own
    private String first;
    private StringList rest;

    /**
     * Constructor for objects of class NESL.
     * 
     * @param first   the first String in the list
     * @param rest    all but the first entry (another StringList)
     */
    public NESL(String first, StringList rest)
    {
        // initialise instance variables
        this.first = first;
        this.rest = rest;
    }

    /**
     * get the first element.
     * 
     * @return the first String
     */
    public String getFirst ()
    {
        return this.first;
    }
    
    /**
     * get the rest.
     * 
     * @return all but the first String
     */
    public StringList getRest ()
    {
        return this.rest;
    }

    /**
     * Is the list empty?
     * 
     * @return no, it isn't
     */
    public boolean isEmpty ()
    {
        return false;
    }

    /**
     * How many strings are in the list?
     * 
     * @return an int
     * @since v1
     */
    public int length ()
    {
        // this               NESL
        // this.first         String
        // this.rest          StringList
        // this.rest.length() int
        return 1 + this.rest.length();
    }
}
