
import tester.*;

/**
 * Testing class StringListTest.
 * 
 * @author Stephen Bloch
 * @version 1b, 2 Mar 2009
 */
public class StringListTest
{
    // Instance variables go here, typically examples to test.
    // For example, if you're testing the Date class, you might say
    // Date myBirthday = new Date(1964, 1, 27);
    // Date millennium = new Date(2001, 1, 1);
    private ESL esl = new ESL();
    private NESL aList = new NESL("Bob", new NESL("Phyllis", this.esl));
    private StringList mt = new ESL();
    private StringList a = new NESL("a",this.mt);
    private StringList b = new NESL("b",this.mt);
    private StringList ab = new NESL("a",this.b);
    private StringList abc = new NESL("a", new NESL("b", new NESL("c", this.mt)));

    /**
     * Run all test methods in the class.
     */
    public static void testEverything ()
    {
        Tester.run (new StringListTest());
    }

        /**
         * Test constructor and getters.
         * 
         * @param  t   the Tester to use
         */
        public void testBasics (Tester t)
        {
            t.checkExpect (this.aList.getFirst(), "Bob");
            t.checkExpect (this.aList.getRest(), new NESL("Phyllis", new ESL()));
            t.checkExpect (((NESL)this.a).getFirst(), "a");
            t.checkExpect (((NESL)this.a).getRest(), this.mt);
            t.checkExpect (((NESL)this.abc).getFirst(), "a");
            NESL bc = (NESL)((NESL)this.abc).getRest();
            t.checkExpect (bc.getFirst(), "b");
            t.checkExpect (((NESL)bc.getRest()).getFirst(), "c");
            t.checkExpect (bc, new NESL("b", new NESL("c", new ESL())));
        }
        
        /**
         * Does the isEmpty method work?
         * 
         * @param  t  the Tester
         */
        public void testIsEmpty (Tester t)
        {
            t.checkExpect (StringListMethods.isEmpty(this.mt), true);
            t.checkExpect (StringListMethods.isEmpty(this.a), false);
            t.checkExpect (StringListMethods.isEmpty(((NESL)this.abc).getRest()), false);
        }
        
        /**
         * Does the length method work?
         * 
         * @param  t  the Tester
         */
        public void testLength (Tester t)
        {
            t.checkExpect (StringListMethods.length(this.mt), 0);
            t.checkExpect (StringListMethods.length(this.a), 1);
            t.checkExpect (StringListMethods.length(this.b), 1);
            t.checkExpect (StringListMethods.length(this.ab), 2);
            t.checkExpect (StringListMethods.length(this.abc), 3);
            t.checkExpect (StringListMethods.length(
                           new NESL("H", new NESL("He", new NESL("Li",
                           new NESL("Be", new NESL("B", new NESL("C",
                           new NESL("N", new NESL("O", new NESL("F",
                           this.mt)))))))))), 9);
        }
}
