/**
 * A list of strings.
 * 
 * @author Stephen Bloch
 * @version 2, 3 March 2009
 */

public abstract class StringList
{
    /**
     * Is the list empty?
     * 
     * @return true if it's empty, false if not
     */
    public abstract boolean isEmpty ();
    
    /**
     * How many strings are in the list?
     * 
     * @return an int
     * @since v1
     */
    public abstract int length ();
    
    /**
     * Convert the StringList to a readable String form.
     * 
     * @return a String, e.g. "[abc,[def,[]]]"
     * @since v2
     */
    public abstract String toString ();
    
    /**
     * Concatenate all the Strings in the list into one.
     * 
     * @return a big long String
     * @since v2
     */
    public abstract String concatAll();
}
