/**
 * A non-empty list of strings.
 * 
 * @author Stephen Bloch
 * @version 3, 3 March 2009
 */
public class NESL extends StringList
{
    // instance variables - replace the example below with your own
    private String first;
    private StringList rest;

    /**
     * Constructor for objects of class NESL.
     * 
     * @param first   the first String in the list
     * @param rest    all but the first entry (another StringList)
     */
    public NESL(String first, StringList rest)
    {
        // initialise instance variables
        this.first = first;
        this.rest = rest;
    }

    /**
     * get the first element.
     * 
     * @return the first String
     */
    public String getFirst ()
    {
        return this.first;
    }
    
    /**
     * get the rest.
     * 
     * @return all but the first String
     */
    public StringList getRest ()
    {
        return this.rest;
    }

    /**
     * Is the list empty?
     * 
     * @return no, it isn't
     */
    public boolean isEmpty ()
    {
        return false;
    }

    /**
     * How many strings are in the list?
     * 
     * @return an int
     * @since v1
     */
    public int length ()
    {
        // this               NESL
        // this.first         String
        // this.rest          StringList
        // this.rest.length() int
        return 1 + this.rest.length();
    }

    /**
     * Convert the StringList to a readable String form.
     * 
     * @return a String, e.g. "[abc,[def,[]]]"
     * @since v2
     */
    public String toString ()
    {
        // this                    NESL
        // this.first              String "H"
        // this.rest               StringList new NESL("He", new NESL("Li", ...))
        // this.rest.toString()    String "[He,[Li,[Be,...]]]"
        // right answer            String "[H,[He,[Li,[Be,...]]]]"
        return "[" + this.first + "," + this.rest.toString() + "]";
    }
    

    /**
     * Concatenate all the Strings in the list into one.
     * 
     * @return a big long String
     * @since v2
     */
    public String concatAll()
    {
        // inventory goes here -- don't skip this step!
        return "This method hasn't been written yet.";
    }
    
    /**
     * Does the StringList contain "onions" as an item?
     * 
     * @return a boolean
     * @since v3
     */
    public boolean containsOnions()
    {
        // this                         NESL
        // this.first                   String
        // this.rest                    StringList
        // "onions"                     a fixed String we'll need
        // this.rest.containsOnions()   boolean
        return this.first.equals("onions") || this.rest.containsOnions();
    }
}
