/**
 * A list of strings.
 * 
 * @author Stephen Bloch
 * @version 3, 3 March 2009
 */

public abstract class StringList
{
    /**
     * Is the list empty?
     * 
     * @return true if it's empty, false if not
     */
    public abstract boolean isEmpty ();
    
    /**
     * How many strings are in the list?
     * 
     * @return an int
     * @since v1
     */
    public abstract int length ();
    
    /**
     * Convert the StringList to a readable String form.
     * 
     * @return a String, e.g. "[abc,[def,[]]]"
     * @since v2
     */
    public abstract String toString ();
    
    /**
     * Concatenate all the Strings in the list into one.
     * 
     * @return a big long String
     * @since v2
     */
    public abstract String concatAll();
    
    /**
     * Does the StringList contain "onions" as an item?
     * 
     * @return a boolean
     * @since v3
     */
    public abstract boolean containsOnions();
    
    /**
     * Add a String at the beginning of an existing StringList.  Could get the
     * same effect by using the NESL constructor, but this is more convenient.
     * 
     * @param newItem  a String to insert at the front
     * @return a NESL containing all the contents of this, preceded by newItem
     * @since v3
     */
    public NESL add(String newItem)
    {
        // this               StringList
        // newItem            String
        return new NESL(newItem, this);
    }
    
}
